//+------------------------------------------------------------------+
//|                                              4H Box Breakout.mq4 |
//|                                                Copyright  2009. |
//|                                           http://strategy4you.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009."
#property link      "http://strategy4you.ru"
extern int          Algoritm=0;    //   :
                                   // 0-      
                                   // 1-  ,       
extern double       Lot=0.0;       //  ( 0 -  )
extern int          MaxRisk=2;     // %   (  )
extern int          Delta=10;      //    
extern int          DeltaLoss=20;  //    
extern int          HourOpen=0;    //    
string StrategyName="4H Box Breakout";
int    Magic=90906;
bool   work=true;
double TakeProfit=0;
double StopLoss=0;
double H=0;
double L=0;
bool   Week=false;
//+------------------------------------------------------------------+
int init()
{if(Period()!=PERIOD_H4)
   {Alert("      H4!"); work=false;}
 if(Algoritm!=0 && Algoritm!=1)
   {Alert("   !");work=false;}
 if(Lot!=0 && Lot<MarketInfo(Symbol(),MODE_MINLOT))
   {Alert("   !"); work=false;}
 if(Lot!=0 && Lot>MarketInfo(Symbol(),MODE_MAXLOT))
   {Alert("   !"); work=false;}
 if(Lot==0 && MaxRisk<1)
   {Alert("  %      !"); work=false;}
 if(Lot==0 && MaxRisk>100)
   {Alert("  %      !"); work=false;}
return(0);}
//+------------------------------------------------------------------+
int deinit() {Comment(""); return(0);}
//+------------------------------------------------------------------+
int start()
{if(!work) {Comment("  !  ."); return(0);}
 if(DayOfWeek()==0 || DayOfWeek()==6) return(0); //    
 if(!IsTradeAllowed()) return(0); //     
 double mLot=Lot;
 if(Lot==0.0) mLot=GetOptimalLot(MaxRisk);
 double tLot=NormLot(mLot/3);
 double Lot1=tLot;
 double Lot2=IIF(mLot-Lot1>0,tLot,0);
 double Lot3=IIF(mLot-Lot1-Lot2>0,mLot-Lot1-Lot2,0);
 double Spred=MarketInfo(Symbol(),MODE_SPREAD)*Point;
 Comment("http://strategy4you.ru");
//...   
 Week=false;
 bool test=IsTesting() || IsOptimization();
 string gvn="S4y"+Magic+"_"+Symbol()+"_";
 if(!test)
   {if(GlobalVariableCheck(gvn+"H")) H=GlobalVariableGet(gvn+"H");
    if(GlobalVariableCheck(gvn+"L")) L=GlobalVariableGet(gvn+"L");}
 if(TimeDayOfWeek(Time[1])==1 && TimeHour(Time[1])==HourOpen)
   {H=NormalizeDouble(High[1],Digits); L=NormalizeDouble(Low[1],Digits);
    if(!test) {GlobalVariableSet(gvn+"H",H); GlobalVariableSet(gvn+"L",L);}
    Week=true;}
//... 
 int oBuy=0,oSell=0,sBuy=0,sSell=0;
 for(int i=0;i<OrdersTotal();i++)
   if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
     if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
       {if(OrderType()==OP_BUY) oBuy++;
        if(OrderType()==OP_SELL) oSell++;
        if(OrderType()==OP_BUYSTOP) sBuy++;
        if(OrderType()==OP_SELLSTOP) sSell++;}
//...         
 if(oBuy+oSell>0)
   for(i=0;i<OrdersTotal();i++)
     if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
       if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
         {if(OrderType()==OP_BUYSTOP && oSell>0) DelOrder();
          if(OrderType()==OP_SELLSTOP && oBuy>0) DelOrder();
          if(OrderType()==OP_BUY)
            if(OrderOpenPrice()>OrderStopLoss() && OrderOpenPrice()+(H-L)<Bid)
              EditOrder(OrderOpenPrice(),OrderTakeProfit(),OrderOpenPrice()+Spred);
          if(OrderType()==OP_SELL)
            if(OrderOpenPrice()<OrderStopLoss() && OrderOpenPrice()-(H-L)>Ask)
              EditOrder(OrderOpenPrice(),OrderTakeProfit(),OrderOpenPrice()-Spred);}
//...  
 if(oBuy+oSell+sBuy+sSell==0 && Week)
   {double level=MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;
    if((H-Ask)<level)
      {Print("     !   .");
       H=Ask+level;}
    if((Bid-L)<level)
      {Print("     !   .");
       L=Bid-level;}
    StopLoss=(H-L)+DeltaLoss*Point;
    double bp=H+Delta*Point;
    double sp=L-Delta*Point;
    if(Lot1>0) NewOrder(OP_BUYSTOP,Lot1,bp,bp+(H-L),L-StopLoss);
    if(Lot2>0) NewOrder(OP_BUYSTOP,Lot2,bp,bp+(H-L)*2,L-StopLoss);
    if(Lot3>0) NewOrder(OP_BUYSTOP,Lot3,bp,bp+(H-L)*3,L-StopLoss);
    if(Lot1>0) NewOrder(OP_SELLSTOP,Lot1,sp,sp-(H-L),H+StopLoss);
    if(Lot2>0) NewOrder(OP_SELLSTOP,Lot2,sp,sp-(H-L)*2,H+StopLoss);
    if(Lot3>0) NewOrder(OP_SELLSTOP,Lot3,sp,sp-(H-L)*3,H+StopLoss);
    Week=false;}
//...
return(0);}
//+------------------------------------------------------------------+
double IIF(bool usl,double zn1,double zn2)
{if(usl) return(zn1); else return(zn2);}
//+------------------------------------------------------------------+
int NewOrder(int Cmd,double lot,double pr=0,double tp=0,double sl=0)
{int tick=0;
 double a=0,b=0;
 for(int er=0;er<3;er++)
   {while(!IsTradeAllowed()) Sleep(100);
    a=MarketInfo(Symbol(),MODE_ASK);
    b=MarketInfo(Symbol(),MODE_BID);
    if(pr==0)
      {if(Cmd==OP_BUY) pr=a;
       if(Cmd==OP_SELL) pr=b;}
    if(Algoritm==0)
      {if(StopLoss>0 && sl==0)
         {if(Cmd==OP_BUY) sl=a-StopLoss*Point;
          if(Cmd==OP_SELL) sl=b+StopLoss*Point;}
       if(TakeProfit>0 && tp==0)
         {if(Cmd==OP_BUY) tp=a+TakeProfit*Point;
          if(Cmd==OP_SELL) tp=b-TakeProfit*Point;}
       tick=OrderSend(Symbol(),Cmd,lot,pr,3,sl,tp,StrategyName,Magic,0,CLR_NONE);
       if(tick>0) break;}
    if(Algoritm==1)
      {if(tick==0) tick=OrderSend(Symbol(),Cmd,lot,pr,3,0,0,StrategyName,Magic,0,CLR_NONE);
       if(tick>0)
         {while(!IsTradeAllowed()) Sleep(100);
          if(OrderSelect(tick,SELECT_BY_TICKET))
            {if(StopLoss>0 && sl==0)
               {if(Cmd==OP_BUY) sl=OrderOpenPrice()-StopLoss*Point;
                if(Cmd==OP_SELL) sl=OrderOpenPrice()+StopLoss*Point;}
             if(TakeProfit>0 && tp==0)
               {if(Cmd==OP_BUY) tp=OrderOpenPrice()+TakeProfit*Point;
                if(Cmd==OP_SELL) tp=OrderOpenPrice()-TakeProfit*Point;}
             if(OrderModify(tick,OrderOpenPrice(),sl,tp,0,CLR_NONE)) break;}}
   }
    Print("#",er,"  Error: ",GetLastError()," Function: NewOrder(",Cmd,",",lot,",",pr,",",tp,",",sl,")");
    Sleep(1000);}
return(tick);}
//+------------------------------------------------------------------+
void EditOrder(double pr,double tp,double sl)
{for(int er=0;er<3;er++)
  {while(!IsTradeAllowed()) Sleep(100);
   if(OrderModify(OrderTicket(),pr,sl,tp,0,CLR_NONE)) break;
   Print("#",er,"  Error: ",GetLastError()," Function: EditOrder(",pr,",",tp,",",sl,")");
   Sleep(1000);}}
//+------------------------------------------------------------------+
void DelOrder()
{for(int er=0;er<3;er++)
  {while(!IsTradeAllowed()) Sleep(100);
   if(OrderDelete(OrderTicket(),CLR_NONE)) break;
   Print("#",er,"  Error: ",GetLastError()," Function: DelOrder()");
   Sleep(1000);}}
//+------------------------------------------------------------------+
double NormLot(double lot)
{double Min_Lot=MarketInfo(Symbol(),MODE_MINLOT);
 double Max_Lot=MarketInfo(Symbol(),MODE_MAXLOT);
 double Step   =MarketInfo(Symbol(),MODE_LOTSTEP);
 int    DigLot =0;
 if(Step<0.1)  DigLot=2;
 if(Step>=0.1) DigLot=1;
 if(Step>=1)   DigLot=0;
 if(lot<Min_Lot) lot=Min_Lot;
 if(lot>Max_Lot) lot=Max_Lot;
return(NormalizeDouble(lot,DigLot));}
//+------------------------------------------------------------------+
double GetOptimalLot(int Percent)
{double Free    =AccountFreeMargin();
 double One_Lot =MarketInfo(Symbol(),MODE_MARGINREQUIRED);
 double Step    =MarketInfo(Symbol(),MODE_LOTSTEP);
 double Lots_New=MathFloor(Free*Percent/100/One_Lot/Step)*Step;
return(NormLot(Lots_New));}
//+------------------------------------------------------------------+